Bug 53634 - mod_cache returning HTTP 200 for nonexistent resources
Summary: mod_cache returning HTTP 200 for nonexistent resources
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_cache (show other bugs)
Version: 2.2.22
Hardware: Other Linux
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2012-08-01 12:23 UTC by glen.birnie
Modified: 2018-11-07 21:09 UTC (History)
1 user (show)



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description glen.birnie 2012-08-01 12:23:31 UTC
IF a 404 ErrorDocument is configured within a URL range where mod_cache is enabled
AND the error document was previously requested (and cached by mod_disk_cache) THEN all subsequent responses to nonexistent resources return HTTP 200 instead of the expected HTTP 404 response.

Example configuration:

###

LoadModule cache_module modules/mod_cache.so
LoadModule disk_cache_module modules/mod_disk_cache.so

CacheRoot /cache-root
CacheDirLevels 3
CacheDirLength 1
CacheMinFileSize 0
CacheMaxFileSize 1000000

CacheEnable disk /

ErrorDocument 404 /error.jpg

###

Assumptions:

/cache-root exists and is writable by httpd, initially empty contents.
/error.jpg exists within the document root directory.

To reproduce:

request "/error.jpg"
request any nonexistent resource, say, "/nonexistent".

NB Bug 49996 describes a very similar issue involving mod_proxy.
Comment 1 Christophe JAILLET 2012-10-21 13:33:08 UTC
Confirmed.

I reproduced it on trunk, with mod_cache_disk.
Comment 2 William A. Rowe Jr. 2018-11-07 21:09:07 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.